---
title: Mozilla Release Checklist
slug: Mozilla/Developer_guide/Build_Instructions/Mozilla_Release_Checklist
tags:
  - Build documentation
  - Developing Mozilla
  - Guide
---
<p>Outdated: last updated in 2005.</p>

<p>This is a checklist used by <code><a class="external" href="http://www.mozilla.org/roadmap.html#project-management">drivers@mozilla.org</a></code> to help ensure that the right things happen before a release, and to give others a rough idea of how our release process works. The build team probably has a separate (and probably better) version of some parts of this list.</p>

<p>If you have additions or suggestions for this list, please note them {{ interwiki('wikimo', 'MozillaReleaseChecklist', 'at the wiki') }} and one of will migrate appropriate additions from there to here.</p>

<h3 id="Get_the_right_fixes_in">Get the right fixes in</h3>

<ul>
 <li>Search for bugs nominated with the <code>blocking<em>{{ mediawiki.external('R') }}</em>?</code> bug flag, and mark them <code>+</code> or <code>-</code>.</li>
 <li>Encourage owners of <code>blocking<em>{{ mediawiki.external('R') }}</em>+</code> bugs (and perhaps some bugs that are close but not quite blocking) to fix the bugs.</li>
 <li>Keep an eye on talkback data, and nominate relevant bugs.</li>
 <li>Handle approval requests (the <code>approval{{ mediawiki.external('R') }}?</code> patch flag) once the tree is frozen for the release.</li>
 <li>Look for regressions in difficult-to-test areas such as memory leaks.</li>
</ul>

<h3 id="Make_a_branch">Make a branch</h3>

<p>If it's a final release (rather than an alpha or beta release), a branch needs to be made. This is done once almost all of the necessary fixes are in. Before deciding that it's really time to release, drivers listen to feedback from people using the builds to make sure that they're good quality, and, before making the final decision, verify that talkback is working and run the smoketests plus a few additional tests.</p>

<p>When it's time to release, drivers let the build team know that it's time to tag the release and make the final builds (usually with some advance warning with some uncertainty). The build team cuts a branch by pulling a tree and <a href="/en/Creating_a_Release_Tag" title="en/Creating_a_Release_Tag">tagging</a> a base tag and (with <code>cvs tag -b</code>) a branch tag. Note that the minibranch mentioned on the tagging instructions isn't necessary here, since the pull scripts are updated on the branch itself.</p>

<p>The tagged files are more than just the <a href="/en/Unix_Detailed_Build_Instructions#Get_the_Code" title="en/Unix_Detailed_Build_Instructions#Get_the_Code">default pull</a> by the build scripts. They should also include <code>mozilla/other-licenses/libart_lgpl/</code>, <code>mozilla/tools/trace-malloc/</code>, <code>mozilla/tools/jprof/</code>, <code>mozilla/tools/codesighs/</code>, <code>mozilla/toolkit/</code>, <code>mozilla/chrome/</code>, <code>mozilla/other-licenses/branding/</code>, <code>mozilla/other-licenses/7zstub/</code>, <code>mozilla/browser/</code>, <code>mozilla/mail/</code>, <code>mozilla/composer/</code> (and probably some other stuff that I missed).</p>

<p>The following command will checkout these additional files:</p>

<pre>cvs co                                \
  mozilla/other-licenses/libart_lgpl/ \
  mozilla/tools/trace-malloc/         \
  mozilla/tools/jprof/                \
  mozilla/tools/codesighs/            \
  mozilla/toolkit/                    \
  mozilla/chrome/                     \
  mozilla/other-licenses/branding/    \
  mozilla/other-licenses/7zstub/      \
  mozilla/browser/                    \
  mozilla/mail/                       \
  mozilla/composer/
</pre>

<p>When the branch is made, create the <code>blocking<em>{{ mediawiki.external('R') }}</em></code> bug nomination flags for the next release.</p>

<h3 id="Notify_the_sysadmins">Notify the sysadmins</h3>

<p>With our growing popularity, releases tend to cause us LOTs of bandwidth usage on our servers. As soon as a date has been set for the release (and preferably a week or so in advance) be sure to notify <a class="link-mailto" href="mailto:sysadmins@mozilla.org">sysadmins@mozilla.org</a> that a release is pending, so that proper preparations for having bandwidth available can be made. This is especially important for our FTP mirror network so we can avoid potential conflicts with other projects who share the same mirrors.</p>

<h3 id="Update_the_version_numbers">Update the version numbers</h3>

<p>The version number updates have to be done twice. When the release is off the trunk they need to be done before the release, and some need to be done again after the release (to make things, e.g., <code>1.3b+</code> rather than <code>1.3b</code>). When the release is off a branch, the version numbers need to be updated on the branch and on the trunk after the branch.</p>

<ul>
 <li>Mozilla version updates:
  <ul>
   <li>update version in <code>config/milestone.txt</code> and <code>xpfe/bootstrap/macbuild/Contents/Info.plist</code>.</li>
   <li><code>localeVersion</code> update, if there are localization changes: update <code>config/chrome-versions.sh</code>. This should generally happen for all releases except for 1.x.y dot releases.</li>
   <li><em>If significant theme changes have happened that require modifications to external themes</em>, <code>skinVersion</code> update (all <code>contents-region.rdf</code> files - search <a class="external" href="http://lxr.mozilla.org/seamonkey/">LXR</a> and build's <code>chrome/chrome.rdf</code> for <code>skinVersion</code> to verify)</li>
   <li>If this is the first release of the new year, bump the copyright year in <code>xpfe/global/resources/locale/en-US/about.xhtml</code>, <code>toolkit/content/about.xhtml</code>, <code>browser/locales/en-US/chrome/browser/aboutDialog.dtd</code>, <code>mail/locales/en-US/chrome/messenger/aboutDialog.dtd</code>, <code>browser/base/content/credits.xhtml</code>, <code>mail/locales/en-US/chrome/messenger/credits.html</code>, <code>browser/app/nsBrowserApp.cpp</code>, <code>xulrunner/examples/simple/simple.xulapp</code>, <code>calendar/sunbird/app/nsCalendarApp.cpp</code>, <code>xpfe/bootstrap/macbuild/Contents/Info.plist</code>, <code>browser/app/macbuild/Contents/Info.plist.in</code>, <code>mail/app/macbuild/Contents/Info.plist.in</code>, <code>xulrunner/app/macbuild/Contents/Info.plist.in</code>, and <code>calendar/sunbird/app/macbuild/Contents/Info.plist.in</code>.</li>
  </ul>
 </li>
 <li>Application version updates:
  <ul>
   <li>Browser
    <ul>
     <li>browser/app/module.ver</li>
     <li>browser/config/version.txt</li>
     <li>browser/installer/unix/installer.cfg</li>
     <li>browser/installer/windows/installer.cfg</li>
    </ul>
   </li>
   <li>Mail
    <ul>
     <li>mail/app/module.ver</li>
     <li>mail/config/version.txt</li>
     <li>mail/installer/windows/installer.cfg</li>
    </ul>
   </li>
  </ul>
 </li>
</ul>

<p>Also, for final releases only, remove the Debug and QA menus, build number, etc. (See {{ Bug(180823) }}, {{ Bug(163246) }}, and {{ Bug(139335) }}.)</p>

<h3 id="Make_release_builds">Make release builds</h3>

<p>When it's time to release, drivers let the build team know that it's time to tag the release and make the final builds (usually with some advance warning with some uncertainty). The build team pulls the tree and <a href="/en/Creating_a_Release_Tag" title="en/Creating_a_Release_Tag">tags the release</a> (see <a href="#what_to_tag">above</a> for comments on tagged files) and makes the necessary builds for the major platforms. (See the <a href="/en/Mozilla_Release_Build_Notes" title="en/Mozilla_Release_Build_Notes">Mozilla Release Build Notes</a>.) Additional builds will be contributed for other platforms and for specific distributions (i.e., RPMS). Be sure to create a <code>contrib</code> directory under the main release directory so that these builds have a place to go.</p>

<p>(Often this actually happens in reverse. That is, a certain set of nightly builds, which have already been tested (see above, on deciding when to release) are declared to be the release, and then the corresponding source is tagged. If it doesn't happen this way, then the resulting builds definitely need to be tested before they are declared to be the release.)</p>

<p>When making the builds, the network installers need to be extracted and repackaged or rebuilt so that they point to the releases directory on the FTP site.</p>

<p>Update log analysis scripts to start grabbing download stats for the new release.</p>

<h3 id="Announce_the_release">Announce the release</h3>

<ul>
 <li>Write the release notes page and <a class="external" href="http://www.mozilla.org/contribute/writing/cvs">check it in</a>.</li>
 <li>Create the <code>blocking<em>{{ mediawiki.external('R') }}</em></code> bug nomination flags for the next release and retire the <code>blocking{{ mediawiki.external('R') }}</code> and <code>approval{{ mediawiki.external('R') }}</code> sets of flags for the current release (possibly after pushing out some of the requests to the next release).</li>
 <li>Send the talkback team the identifiers from the master.ini files of the three major platforms.</li>
 <li>Make web page changes, which should land after the builds are on all the FTP servers:
  <ul>
   <li>Update the <a class="external" href="http://www.mozilla.org/news.html"><code>news.html</code></a> with an announcement of the release.</li>
   <li>Update <code>VARIABLES</code> with the new version numbers and URLs.</li>
   <li>For Mozilla releases, update <a class="external" href="http://www.mozilla.org/releases/"><code>releases/index.html</code></a> and <code>releases/&lt;version&gt;/index.html</code></li>
   <li>For Firefox releases, update <code><a class="external" href="http://www.mozilla.org/products/firefox/releases/" rel="freelink">http://www.mozilla.org/products/firefox/releases/</a>&lt;version&gt;.html</code> and change <code>httpd.conf</code> so that index.html points to it</li>
   <li>For Thunderbird releases, update <code><a class="external" href="http://www.mozilla.org/products/thunderbird/releases/" rel="freelink">http://www.mozilla.org/products/thunderbird/releases/</a>&lt;version&gt;.html</code> and copy that to <code>index.html</code></li>
   <li>Update <a href="/en/CVS_Tags" title="en/CVS_Tags">CVS Tags</a> doc to include the newest release tag.</li>
   <li>Update the "actual release" field in <a class="external" href="http://www.mozilla.org/roadmap.html">roadmap.html</a>.</li>
  </ul>
 </li>
 <li>(Build team) Update the README for FTP.</li>
 <li>Once the release is on the FTP server, commit the changes to the front page and the releases page and restart the website script.</li>
 <li>Double-check that all the links are correct and that the builds have propagated to all the FTP round-robin machines.</li>
 <li>Send the release announcement to n.p.m.announce.</li>
 <li>Submit notes to mozillazine, slashdot and newsforge.</li>
</ul>

<div class="originaldocinfo">
<h2 id="Original_Document_Information">Original Document Information</h2>

<ul>
 <li>Author(s): David Baron</li>
 <li>Last Updated Date: March 22, 2005</li>
 <li>Copyright Information: Portions of this content are © 1998–2007 by individual mozilla.org contributors; content available under a Creative Commons license | <a class="external" href="http://www.mozilla.org/foundation/licensing/website-content.html">Details</a>.</li>
</ul>
</div>

